# breitensuche-viele.py
# mehrere Container als tiefe Liste
# iterative Variante mit HGT


# Globale Variable für die Stücke:
stuecke=[30,30,30,30,30,20,20,20,20,20]
# interessanter:
##stuecke=[70,60,50,40,20,20,20]

### Hilfsfunktionen
def erzeuge_Container(fassungsvermoegen):
    return [fassungsvermoegen, []]

def fuelle_ein(stueck, container):
    inhalt=[]+container[1] # echte Kopie erzeugen!
    inhalt.append(stueck)
    return [container[0], inhalt]

### Prädikat zum Testen, ob der Container voll ist.
def ist_voll(container):
    return container[0]==sum(container[1])
def alle_voll(alleContainer):
    for container in alleContainer:
        if not(ist_voll(container)):
            return False
    return True
### ... mit dem Stück zu voll wird.
def wird_zu_voll(stueck, container):
    return container[0]<stueck+sum(container[1])

def breitensuche(stuecke, alternativen):
    ##input(str(stuecke)+'  '+str(alternativen))
    for alternative in alternativen: # Erfolgsfall testen
        if alle_voll(alternative):
            return alternative
    if len(stuecke)==0:
        return False
    print(stuecke[0])
    # über alle Alternativen iterieren
    akku = []
    for alternative in alternativen:
        # mit dem Stück in allen Containern versuchen
        for i in range(len(alternative)):
            if not(wird_zu_voll(stuecke[0], alternative[i])):
                akku.append(alternative[:i]+
                            [fuelle_ein(stuecke[0],alternative[i])]+
                            alternative[i+1:])
        # und ohne das Stück
        akku.append(alternative)
    return breitensuche(stuecke[1:], akku)

### Tests:
def ausgabe(stuecke, containerliste):
    print('Stücke:', stuecke, containerliste,
          'Ergebnis:\n', breitensuche(stuecke, containerliste), '\n')

ausgabe( stuecke, [[erzeuge_Container(80),erzeuge_Container(100)]])
ausgabe( stuecke*2, [[erzeuge_Container(80),
                      erzeuge_Container(100),
                      erzeuge_Container(130)]] )
