﻿# fuelle-breitensuche.py
# Programm zum Füllen eines Containers mit Breitensuche
# (Rucksackproblem)
# Die hier beschriebene Variante ist die ganz "doofe", bei der
# erst am Schluss getestet wird, ob die Teile wirklich passten.


# Globale Variable für die Stücke:
stuecke=[30,30,20,20]

def expandiere(stueck, containerVarianten):
    ergebnisse=[]
    for container in containerVarianten:
        ergebnisse+=[container, container+[stueck]]
    return ergebnisse

def fuelle(stuecke, containerVarianten, fassungsvermoegen):
    if len(stuecke)==0:
        ergebnisse=[]
        for container in containerVarianten:
            if fassungsvermoegen==sum(container):
               ergebnisse+=[container]
        return ergebnisse
    else:
        return fuelle(stuecke[1:],
                      expandiere(stuecke[0], containerVarianten),
                      fassungsvermoegen)
   

def ausgabe(stuecke, fassungsvermoegen):
    print("breitensuche mit ",
          stuecke,
          " Kapazitaet ",
          fassungsvermoegen,
          " ergibt:\n",
          fuelle(stuecke,[[]] , fassungsvermoegen), '\n')

# Testaufrufe:
ausgabe(stuecke,100)
ausgabe(stuecke,170)
ausgabe(stuecke,sum(stuecke))
ausgabe(stuecke,33)
ausgabe(stuecke,1000)
ausgabe([70,60,50,40,30,20,20], 260)
